'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 10. A function can be declared inline
'If a function contains just simple lines of code, doesn't use for loops or the
'like, it can be declared inline. This means its code will be inserted everywhere
'the function is used. That's somewhat like a macro. The main advantage is the 
'program will be faster. A small drawback is it will be bigger, because the full
'code of the function was inserted everywhere it is used. 
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================
inline FUNCTION hypothenuse (a AS double, b AS double) AS double
	FUNCTION = sqrt (a * a + b * b)
END FUNCTION
'============================================================================== 
FUNCTION main ()

	Dim As double k = 6, m = 9
 
	' Next two lines produce exactly the same code:

	cout << hypothenuse (k, m) << endl		'result -> 10.8167
	cout << sqrt (k * k + m * m) << endl	'result -> 10.8167
	Pause
	Function = EXIT_SUCCESS
End Function 

