'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 17. You can add METHODS To a class or struct.
'In standard C a struct contains only data. In C++ a struct definition can also
'include functions. Those functions are owned by the struct and are meant to 
'operate on the data of the struct. Those functions are called METHODS. The example
'below defines the method surface() on the struct vector. 
'a bc8Basic PPTYPE is a standard c++ struct
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================
PPType bcx_vector
	Dim As double x
	Dim As double y

	Function surface() As double
 		Raw As double s
 		s = x * y
 		If s < 0 Then
 		    s = -s
 		End If
 		Function = s
	End Function
End PPType
'============================================================================== 
Function main ()
	Raw As bcx_vector a
	a.x = 3
	a.y = 4
	
	cout << "The surface of a: " << a.surface() << endl

	'Result: The surface of a: 12
	Pause
	Function = EXIT_SUCCESS
End Function
