'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 18. The CONSTRUCTOR and the DESTRUCTOR can be used to initialise and 
'destroy an instance of a class
'Very special and essential methods are the CONSTRUCTOR and DESTRUCTOR. They are
'automatically called whenever an instance of a class is created or destroyed
'(variable declaration, end of program, *new*, *delete*...). 
'The constructor will initialize the variables of the instance, do some calculations,
'allocate some memory for the instance, output some text... whatever is needed. 
'Here is an example of a class definition with two overloaded constructors 
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================
Class x_vector
	public:
		Raw As double x,y
      
		Constructor x_vector()   ' same name as class
       		x = 0
       		y = 0
		End Constructor
 
		Constructor x_vector(a AS double, b AS double)
       		x = a
       		y = b
		End Constructor
End Class
'============================================================================== 
Function main ()
	Raw As x_vector k         ' x_vector () is called
	
	cout << "x_vector k: " << k.x << ", " << k.y << endl << endl
	
	Raw As x_vector m (45, 2) ' x_vector (double, double) is called
	
	cout << "x_vector m: " << m.x << ", " << m.y << endl << endl
	 
	k = x_vector (23, 2)      ' x_vector created, copied to k, then erased
	
	cout << "x_vector k: " << k.x << ", " << k.y << endl << endl
	Pause	
	Function = EXIT_SUCCESS
End Function
