'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 24. static variables inside a class definition
'One or more variables in a class can be declared *static*. In which case, 
'only one instance of those variables exist, shared by all instances of the class.
'It must be initialised outside the class declaration. 
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================
Class x_vector
	public:
		Raw As double x,y
		static As int count

		Constructor x_vector (a = 0 AS double, b = 0 AS double)
			x = a
			y = b
			count++
		End Constructor

		Destructor ~x_vector()
			count--
		End Destructor
End Class
'==============================================================================
Raw As int x_vector::count = 0
'==============================================================================

Function main () As int
	cout << "Number of x_vectors:" << endl
	
	Raw As x_vector a
	cout << x_vector::count << endl
	
	Raw As x_vector b
	cout << x_vector::count  << endl
	
	Raw As x_vector PTR r, u
	
	r = new x_vector
	cout << x_vector::count << endl
	
	u = new x_vector
	cout << a.count << endl
	
	delete r
	cout << x_vector::count << endl
	
	delete u
	cout << b.count << endl
	Pause 
	Function = EXIT_SUCCESS
End Function
