'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 26. A class can be DERIVED from another class.
'A class can be DERIVED from another class. The new class INHERITS the variables
'and methods of the BASE CLASS. Additional variables and/or methods can be added. 
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================

Class x_vector
	public:
		Raw As double x,y

		Constructor x_vector (a = 0 As double, b = 0 As double)
			x = a
			y = b
		End Constructor

		Function module() AS double
			Function = sqrt (x*x + y*y)
		End Function

		Function surface() AS double
			Function = x * y
		End Function
End Class
'==============================================================================
Class trivector Using public x_vector    ' trivector is derived from x_vector 
	public:
		Raw As double z       ' added to x and y from x_vector

		Constructor trivector (m=0 As double, n=0 As double, p=0 As double) Using x_vector (m, n)
			z = p           ' x_vector constructor will
		End Constructor     ' be called before trivector
        			        ' constructor, with parameters
                 			' m and n.

		Constructor trivector (a As x_vector) ' What to do if a x_vector is cast to a trivector
			x = a.x
			y = a.y
			z = 0
		End Constructor

		Function module () As double      ' define module() for trivector
			Function = sqrt (x*x + y*y + z*z)
		End Function

		Function volume () As double
			Function = this->surface() * z    ' or x * y * z
		End Function
End Class
'==============================================================================
Function main () As int
	Raw As x_vector a (4, 5)
	Raw As trivector b (1, 2, 3)

	cout << "a (4, 5)    b (1, 2, 3)    *r = b" << endl << endl
	
	cout << "Surface of a: " << a.surface() << endl
	cout << "Volume of b: " << b.volume() << endl
	cout << "Surface of base of b: " << b.surface() << endl
	
	cout << "Module of a: " << a.module() << endl
	cout << "Module of b: " << b.module() << endl
	cout << "Module of base of b: " << b.x_vector::module() << endl
	
	Raw As trivector k
	k = a                 	' thanks to trivector(x_vector) definition
	                 		' copy of x and y,       k.z = 0
	Raw As  x_vector j
	j = b                 	' copy of x and y.       b.z leaved out
	
	Raw As x_vector Ptr r
	r = &b
	
	cout << "Surface of r: " << r->surface() << endl
	cout << "Module of r: " << r->module() << endl
	
	Pause
	Function = EXIT_SUCCESS
End Function
