'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 27. If a method is declared virtual the program will always check the 
'type of the instance that is pointed to and will use the appropriate method.
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================
Class x_vector
	public:
		Raw As double x,y

		Constructor x_vector (a = 0 As double, b = 0 As double)
			x = a
			y = b
		End Constructor

		Function module() As virtual double
			Function = sqrt (x*x + y*y)
		End Function
End Class
'==============================================================================
Class trivector Using Public x_vector
	public:
		Raw As double z

		Constructor trivector (m = 0 As double, n = 0 As double, p = 0 As double)
			x = m                   ' Just for the game,
			y = n                   ' here I do not call the x_vector
			z = p                   ' constructor and I make the
		End Constructor             ' trivector constructor do the whole job. Same result.

		Function module () As double
			Function = sqrt (x*x + y*y + z*z)
		End Function
End Class
'==============================================================================
Sub test (k As x_vector &)
	cout << "Test result:          " << k.module() << endl
End Sub
'==============================================================================
Function main () As int
	Raw As x_vector a (4, 5)
	Raw As trivector b (1, 2, 3)

	cout << "a (4, 5)    b (1, 2, 3)" << endl << endl

	Raw As x_vector Ptr r

	r = &a
	cout << "module of x_vector a: " << r->module() << endl

	r = &b
	cout << "module of trivector b: " << r->module() << endl

	test (a)

	test (b)

	Raw As x_vector &s = b

	cout << "module of trivector b: " << s.module() << endl

	Pause
	Function = EXIT_SUCCESS
End Function
