'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 11. The exception structure has been added
'------------------------------------------------------------------------------
' You know the classical control structures of C: *for*, *if*, *do*,
' *while*, *switch*... C++ adds one more control structure named EXCEPTION:
'------------------------------------------------------------------------------
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'============================================================================== 
Function main () As int
	Dim As int  a,b, c

	cout << "Type a number: "
	cin >> a
	cout << endl
	
	Try
		If a > 100 Then
			Throw 100
		End If
		
		If a < 10 Then
			Throw 10
		End If
		
		c = a/3
		Throw  c
	Catch (result As int)
		cout << "Result is: " << result << endl
		b = result + 1
	End Try
	
	cout << "b contains: " << b << endl
	
	cout << endl
	Pause
	
	' another example of exception use:
	
	Raw As char zero[]     = "zero" 
	Raw As char even[]     = "even"
	Raw As char notprime[] = "not prime"
	Raw As char prime[]    = "prime"
	
	Try
		If a = 0 Then 
			Throw zero
		End If
		
		If (a / 2) * 2 = a Then
			 Throw even
		End If
		
		xFor int i = 3 While i <= sqrt ((float)a) By i++
			cout << "Testing " << i << endl
			If (a / i) * i = a Then
				Throw notprime
			End If
	 	xNext
	 	Throw prime
	Catch (conclusion AS const char Ptr)
	  	cout << "The number you typed is "<< conclusion << endl
	End Try
	
	cout << endl
	Pause
	Function = EXIT_SUCCESS
End Function
