'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 21. The keyword this is a pointer to the instance a method is acting upon
'When a method is applied to an instance, that method may use the instance's 
'variables, modify them... But sometimes it is necessary to know the address of 
'the instance. No problem, the keyword *this* is intended for that purpose. 
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================
Class x_vector
	Public:
		Raw As double x,y

		Constructor x_vector (a = 0 As double, b = 0 As double)
			x = a
			y = b
		End Constructor

		Function module() AS double
			Function = sqrt (x * x + y * y)
		End Function

		Sub set_length (a = 1 AS double)
			Raw As double length
			length = this->module()
			x = x / length * a
			y = y / length * a
		End Sub
End Class
'==============================================================================
Function main () As int
	Raw As x_vector c (3, 5)

	cout << "The module of x_vector c: " << c.module() << endl

	c.set_length(2)    ' Transforms c in a x_vector of size 2

	cout << "The module of x_vector c: " << c.module() << endl

	c.set_length()      ' Transforms b in an unitary x_vector.

	cout << "The module of x_vector c: " << c.module() << endl
	Pause
	Function = EXIT_SUCCESS
End Function
