'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 23. An example of a complete class declaration
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================
Class x_vector
	public:
		Raw As double x,y
		Dim Constructor x_vector (a = 0 As double, b = 0 As double)
		Dim Constructor x_vector ()

		Dim Function operator + (a As x_vector) As x_vector
		Dim Function operator - (a As x_vector) As x_vector
		Dim Function operator - () As x_vector
		Dim Function operator * (a As double) As x_vector
		Dim Function module() As double
		Dim SUB set_length (A  As double = 1)
End Class
'------------------------------------------------------------------------------
Constructor x_vector::x_vector (a As double, b As double)
	x = a
	y = b
End Constructor
'------------------------------------------------------------------------------
Constructor x_vector::x_vector ()
	x = 0
	y = 0
End Constructor
'------------------------------------------------------------------------------
Function x_vector::operator + (a As x_vector) As x_vector
	Function = x_vector (x + a.x, y + a.y)
End Function
'------------------------------------------------------------------------------
Function x_vector::operator - (a As x_vector) As x_vector
	Function = x_vector (x - a.x, y - a.y)
End Function
'------------------------------------------------------------------------------
Function x_vector::operator - () As x_vector
	Function = x_vector (-x, -y)
End Function
'------------------------------------------------------------------------------
Function x_vector::operator * (a As double) As x_vector
	Function = x_vector (x * a, y * a)
End Function
'------------------------------------------------------------------------------
Function x_vector::module() As double
	Function = sqrt (x * x + y * y)
End Function
'------------------------------------------------------------------------------
Sub x_vector::set_length (a As double)
	Raw As double length = this->module()

	x = x / length * a
	y = y / length * a
End Sub
'==============================================================================
Function operator << (o As ostream&, a As x_vector) As ostream&
	o << "(" << a.x << ", " << a.y << ")";
	Function = o
End Function
'==============================================================================
Function main ()
	Raw As x_vector a,b,c (3, 5)

	a = c * 3
	a = b + c
	c = b - c + a + (b - a) * 7
	c = -c

	cout << "The module of x_vector c: " << c.module() << endl

	cout << "The content of x_vector a: " << a << endl
	cout << "The oposite of x_vector a: " << -a << endl

	c.set_length(2)         ' Transforms c in a x_vector of size 2.

	a = x_vector (56, -3)
	b = x_vector (7, c.y)

	b.set_length()          ' Transforms b in an unitary x_vector.

	cout << "The content of x_vector b: " << b << endl

	Dim As double k

	k = x_vector(1, 1).module()   ' k will contain 1.4142.
	cout << "k contains: " << k << endl

	Pause
	Function = EXIT_SUCCESS
End Function
