'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 28. A class can be derived from more than one base class.
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================
Class x_vector
	public:
		Raw As double x,y

		Constructor x_vector (a = 0 As double, b = 0 As double)
			x = a
			y = b
		End Constructor

		Function surface() As double
			Function = fabs (x * y)
		End Function
End Class
'============================================================================== 
Class number
	public:
		Raw As double z

		Constructor number(a As double)
			z = a
		End Constructor

		Function is_negative() As int
			If z < 0 Then
				Function = 1
			Else
				Function = 0
			End If
		End Function
End Class
'============================================================================== 
Class trivector Using public x_vector, public number
	public:

		Constructor trivector(a=0 As double, b=0 As double, c=0 As double) Using x_vector(a,b), number(c)
		End Constructor	' The trivector constructor calls the x_vector
		               	' constructor, then the number constructor,
		               	' and in this example does nothing more.

		Function volume() As double
			Function = fabs(x * y * z)
		End Function
End Class
'============================================================================== 
Function main() As int
	Raw As trivector a(2, 3, -4)

	cout << a.volume() << endl
	cout << a.surface() << endl
	cout << a.is_negative() << endl
	Pause
	Function = EXIT_SUCCESS
End Function

